/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.models.tipo_egreso;

import danielcortes.xyz.data.ConnectionHolder;
import danielcortes.xyz.data.SQLiteConnectionHolder;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

public class SQLiteTipoEgresoDAO extends TipoEgresoDAO {
    public SQLiteTipoEgresoDAO(){
        this.connectionHolder = new SQLiteConnectionHolder();
    }

    @Override
    public List<TipoEgreso> findAll() {
        List<TipoEgreso> tipoEgresoList = new ArrayList<>();
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("select * from tipos_egreso");
            ResultSet rs = ps.executeQuery();

            tipoEgresoList = this.tipoEgresoFromResultSet(rs);

            rs.close();
            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return tipoEgresoList;
    }

    @Override
    public List<TipoEgreso> findById(int id) {
        List<TipoEgreso> tipoEgresoList = new ArrayList<>();
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("select * from tipos_egreso where id = ?");
            ps.setInt(1, id);
            ResultSet rs = ps.executeQuery();

            tipoEgresoList = this.tipoEgresoFromResultSet(rs);

            rs.close();
            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return tipoEgresoList;
    }

    @Override
    public List<TipoEgreso> findByNombre(String nombre) {
        List<TipoEgreso> tipoEgresoList = new ArrayList<>();
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("select * from tipos_egreso where nombre = ?");
            ps.setString(1, nombre);
            ResultSet rs = ps.executeQuery();

            tipoEgresoList = this.tipoEgresoFromResultSet(rs);

            rs.close();
            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return tipoEgresoList;
    }

    @Override
    public boolean insertTipoEgreso(TipoEgreso tipoEgreso) {
        return false;
    }

    @Override
    public boolean updateTipoEgreso(TipoEgreso tipoEgreso) {
        return false;
    }

    @Override
    public boolean deleteTipoEgreso(TipoEgreso tipoEgreso) {
        return false;
    }

}
